#### connect (7 of 8 overloads)

Establishes a socket connection by trying each endpoint in a sequence.

    template<
        typename Protocol,
        typename Executor,
        typename Iterator,
        typename ConnectCondition>
    Iterator connect(
        basic_socket< Protocol, Executor > & s,
        Iterator begin,
        Iterator end,
        ConnectCondition connect_condition,
        constraint_t< is_connect_condition< ConnectCondition, Iterator >::value >  = 0);

This function attempts to connect a socket to one of a sequence of endpoints. It does this by repeated calls to the socket's `connect` member function, once for each endpoint in the sequence, until a connection is successfully established.

###### Parameters

s

  The socket to be connected. If the socket is already open, it will be closed.

begin

  An iterator pointing to the start of a sequence of endpoints.

end

  An iterator pointing to the end of a sequence of endpoints.

connect_condition

  A function object that is called prior to each connection attempt. The signature of the function object must be:

      bool connect_condition(
         const asio::error_code& ec,
         const typename Protocol::endpoint& next);

  The `ec` parameter contains the result from the most recent connect operation. Before the first connection attempt, `ec` is always set to indicate success. The `next` parameter is the next endpoint to be tried. The function object should return true if the next endpoint should be tried, and false if it should be skipped.

###### Return Value

An iterator denoting the successfully connected endpoint.

###### Exceptions

asio::system_error

  Thrown on failure. If the sequence is empty, the associated `error_code` is `asio::error::not_found`. Otherwise, contains the error from the last connection attempt.

###### Example

The following connect condition function object can be used to output information about the individual connection attempts:

    struct my_connect_condition
    {
      bool operator()(
          const asio::error_code& ec,
          const::tcp::endpoint& next)
      {
        if (ec) std::cout << "Error: " << ec.message() << std::endl;
        std::cout << "Trying: " << next << std::endl;
        return true;
      }
    };

It would be used with the `connect` function as follows:

    tcp::resolver r(my_context);
    tcp::resolver::query q("host", "service");
    tcp::resolver::results_type e = r.resolve(q);
    tcp::socket s(my_context);
    tcp::resolver::results_type::iterator i = asio::connect(
        s, e.begin(), e.end(), my_connect_condition());
    std::cout << "Connected to: " << i->endpoint() << std::endl;